﻿-- Addon: QuestTranslator (version: 50400.02) 2016.06.22
-- Description: AddOn displays translated quest information in original or separete window.
-- Autor: Platine  (e-mail: platine.wow@gmail.com)


-- Global Variables
local QTR_version = "50400.02";
local QTR_name = UnitName("player");
local QTR_class= UnitClass("player");
local QTR_race = UnitRace("player");
local QTR_event="";
local QTR_waitTable = {};
local QTR_waitFrame = nil;
local QuestTranslator_MessOrig = {
      details    = "Description", 
      objectives = "Objectives", 
      rewards    = "Rewards", 
      itemchoose1= "You will be able to choose one of these rewards:", 
      itemchoose2= "Choose one of these rewards:", 
      itemreceiv1= "You will also receive:", 
      itemreceiv2= "You receiving the reward:", 
      learnspell = "Learn Spell:", 
      reqmoney   = "Required Money:", 
      reqitems   = "Required items:", 
      experience = "Experience:", 
      currquests = "Current Quests", 
      avaiquests = "Available Quests", };
local Original_Font1 = "Fonts\\MORPHEUS.ttf";
local Original_Font2 = "Fonts\\FRIZQT__.ttf";
if not QuestTranslator then
   QuestTranslator = { };
end


function QuestTranslator_CheckVars()
  if (not QTR_PS) then
     QTR_PS = {};
  end
  if (not QTR_PC) then
     QTR_PC = {};
  end
  if (not QTR_SAVED) then
     QTR_SAVED = {};
  end
  -- initialize check options
  if (not QTR_PS["active"]) then
     QTR_PS["active"] = "1";   
  end
  if (not QTR_PS["mode"] ) then
     QTR_PS["mode"] = "1";   
  end
  if (not QTR_PS["transtitle"] ) then
     QTR_PS["transtitle"] = "0";   
  end
  if (not QTR_PS["size"] ) then
     QTR_PS["size"] = "1";   
  end
  if (not QTR_PS["width"] ) then
     QTR_PS["width"] = "1";   
  end

  -- set check buttons 
  if (QTR_PS["size"] == "1") then
     QuestTranslator_SizeH = 1;
  else 
     QuestTranslator_SizeH = 2;     
     QuestTranslatorFrame1:SetHeight(525);
     QuestTranslator_QuestDetail:SetHeight(430);
     QTR_ToggleButton2:SetText("^");
  end
  if (QTR_PS["width"] == "1") then
     QuestTranslator_SizeW = 1;
  else 
     QuestTranslator_SizeW = 2;     
     QuestTranslatorFrame1:SetWidth(525);
     QuestTranslator_QuestDetail:SetWidth(495);
     QuestTranslator_QuestTitle:SetWidth(495);
     QTR_ToggleButton3:SetText("<");
  end
  if ( QTR_PS["isGetQuestID"] ) then
     isGetQuestID=QTR_PS["isGetQuestID"];
  end;
end


function QuestTranslator_SetCheckButtonState()
  QuestTranslatorCheckButton0:SetChecked(QTR_PS["active"]=="1");
  QuestTranslatorCheckButton1:SetChecked(QTR_PS["mode"]=="1");
  QuestTranslatorCheckButton2:SetChecked(QTR_PS["mode"]=="2");
  QuestTranslatorCheckButton3:SetChecked(QTR_PS["transtitle"]=="1");
  QuestTranslatorCheckButton4:SetChecked(QTR_PS["size"]=="1");
  QuestTranslatorCheckButton5:SetChecked(QTR_PS["size"]=="2");
  QuestTranslatorCheckButton6:SetChecked(QTR_PS["width"]=="1");
  QuestTranslatorCheckButton7:SetChecked(QTR_PS["width"]=="2");
end


function QuestTranslator_OnLoad1()
  QuestTranslator.frame1 = CreateFrame("Frame");
  QuestTranslator.frame1:RegisterEvent("ADDON_LOADED");
  QuestTranslator.frame1:RegisterEvent("QUEST_LOG_UPDATE");
  QuestTranslator.frame1:SetScript("OnEvent", function(self, event, ...) return QuestTranslator[event] and QuestTranslator[event](QuestTranslator, event, ...) end);
  QuestLogDetailScrollFrame:SetScript("OnShow", QuestTranslator_ShowAndUpdateQuestInfo);
  QuestLogDetailScrollFrame:SetScript("OnHide", QuestTranslator_HideQuestInfo);

  QuestTranslator_QuestTitle:SetFont(QTR_Font2, 17);
  QuestTranslator_QuestDetail:SetFont(QTR_Font2, 14);
  QuestTranslatorFrame1:ClearAllPoints();
  QuestTranslatorFrame1:SetPoint("TOPLEFT", QuestLogFrame, "TOPRIGHT", -3, -12);

  -- small button "QTR" in WorldMapFrame
  QTR_ToggleButton0 = CreateFrame("Button",nil, WorldMapFrame, "UIPanelButtonTemplate");
  QTR_ToggleButton0:SetWidth(160);
  QTR_ToggleButton0:SetHeight(18);
  QTR_ToggleButton0:SetText("Quest aktywny");
  QTR_ToggleButton0:Show();
  QTR_ToggleButton0:ClearAllPoints();
  QTR_ToggleButton0:SetPoint("TOPLEFT", WorldMapFrameSizeDownButton, "TOPLEFT", -200, -40);
  QTR_ToggleButton0:SetScript("OnClick", QuestTranslator_ToggleVisibility);

  -- small button "QTR" in QuestLogFrame
  QTR_ToggleButton1 = CreateFrame("Button",nil, QuestLogFrame, "UIPanelButtonTemplate");
  QTR_ToggleButton1:SetWidth(160);
  QTR_ToggleButton1:SetHeight(18);
  QTR_ToggleButton1:SetText("Quest aktywny");
  QTR_ToggleButton1:Show();
  QTR_ToggleButton1:ClearAllPoints();
  QTR_ToggleButton1:SetPoint("TOPLEFT", QuestLogFrame, "TOPLEFT", 340, -33);
  QTR_ToggleButton1:SetScript("OnClick", QuestTranslator_ToggleVisibility);

  -- button for ChangeFrameHeight
  QTR_ToggleButton2 = CreateFrame("Button",nil, QuestTranslatorFrame1, "UIPanelButtonTemplate");
  QTR_ToggleButton2:SetWidth(15);
  QTR_ToggleButton2:SetHeight(22);
  QTR_ToggleButton2:SetText("v");
  QTR_ToggleButton2:Show();
  QTR_ToggleButton2:ClearAllPoints();
  QTR_ToggleButton2:SetPoint("BOTTOMLEFT", QuestTranslatorFrame1, "BOTTOMRIGHT", -40, 9);
  QTR_ToggleButton2:SetScript("OnClick", QuestTranslator_ChangeFrameHeight);

  -- button for ChangeFrameWidth
  QTR_ToggleButton3 = CreateFrame("Button",nil, QuestTranslatorFrame1, "UIPanelButtonTemplate");
  QTR_ToggleButton3:SetWidth(15);
  QTR_ToggleButton3:SetHeight(22);
  QTR_ToggleButton3:SetText(">");
  QTR_ToggleButton3:Show();
  QTR_ToggleButton3:ClearAllPoints();
  QTR_ToggleButton3:SetPoint("BOTTOMLEFT", QuestTranslatorFrame1, "BOTTOMRIGHT", -25, 9);
  QTR_ToggleButton3:SetScript("OnClick", QuestTranslator_ChangeFrameWidth);

  -- small button "QTR" in QuestFrame with NPC
  QTR_ToggleButton4 = CreateFrame("Button",nil, QuestFrame, "UIPanelButtonTemplate");
  QTR_ToggleButton4:SetWidth(160);
  QTR_ToggleButton4:SetHeight(18);
  QTR_ToggleButton4:SetText("Quest aktywny");
  QTR_ToggleButton4:Show();
  QTR_ToggleButton4:ClearAllPoints();
  QTR_ToggleButton4:SetPoint("TOPLEFT", QuestFrame, "TOPLEFT", 90, -32);
  QTR_ToggleButton4:SetScript("OnClick", QuestTranslator_ToggleVisibility);

  -- small button "QTR" in QuestLogDetailFrame
  QTR_ToggleButton5 = CreateFrame("Button",nil, QuestLogDetailFrame, "UIPanelButtonTemplate");
  QTR_ToggleButton5:SetWidth(160);
  QTR_ToggleButton5:SetHeight(18);
  QTR_ToggleButton5:SetText("Quest aktywny");
  QTR_ToggleButton5:Show();
  QTR_ToggleButton5:ClearAllPoints();
  QTR_ToggleButton5:SetPoint("TOPLEFT", QuestLogDetailFrame, "TOPLEFT", 35, -32);
  QTR_ToggleButton5:SetScript("OnClick", QuestTranslator_ToggleVisibility);
--  WatchFrameLinkButton:SetScript("OnShow", QuestTranslator_ShowAndUpdateQuestInfo);
--  hooksecurefunc("WatchFrameLinkButton_OnClick", function() QuestTranslator_UpdateQuestInfo() end);
  -- wywoływane, gdy kliknięto na tytuł questu w QuestLogu
  hooksecurefunc("QuestLogTitleButton_OnClick", function() QuestTranslator_UpdateQuestInfo() end);
end


function QuestTranslator_OnLoad2()
  QuestTranslator.frame2 = CreateFrame("Frame");
  QuestTranslator.frame2:RegisterEvent("QUEST_GREETING");
  QuestTranslator.frame2:RegisterEvent("QUEST_DETAIL");
  QuestTranslator.frame2:RegisterEvent("QUEST_PROGRESS");
  QuestTranslator.frame2:RegisterEvent("QUEST_COMPLETE");
  QuestTranslator.frame2:RegisterEvent("WORLD_MAP_UPDATE");
  QuestTranslator.frame2:SetScript("OnEvent", function(self, event, ...) return QuestTranslator[event] and QuestTranslator[event](QuestTranslator, event, ...) end);
  QuestTranslator_QuestTitle2:SetFont(QTR_Font2, 17);
  QuestTranslator_QuestDetail2:SetFont(QTR_Font2, 14);
  QuestTranslator_QuestWarning2:SetFont(QTR_Font2, 12);
  QuestTranslatorFrame2:ClearAllPoints();
  QuestTranslatorFrame2:SetPoint("TOPLEFT", QuestFrame, "TOPRIGHT", -1, -19);
  QuestFrame:SetScript("OnHide", QuestTranslator_Frame2Close);
  hooksecurefunc("WorldMapQuestFrame_OnMouseUp", function() QuestTranslator_WorldMapQuestFrameOnMouseUp() end);
end


function QuestTranslator_WorldMapQuestFrameOnMouseUp()
  QTR_event = "WORLD_MAP_OnMouseUp";
  QuestTranslator_OnEvent2();
end


function QuestTranslator_SlashCommand(msg)
   if (msg=="on" or msg=="ON") then
      if (QTR_PS["active"]=="1") then
         print ("QTR - tłumaczenia są włączone.");
      else
         print ("|cffffff00QTR - włączam tłumaczenia.");
         QTR_PS["active"] = "1";
      end
   elseif (msg=="off" or msg=="OFF") then
      if (QTR_PS["active"]=="0") then
         print ("QTR - tłumaczenia są wyłączone.");
      else
         print ("|cffffff00QTR - wyłączam tłumaczenia.");
         QTR_PS["active"] = "0";
      end
   elseif (msg=="title on" or msg=="TITLE ON") then
      if (QTR_PS["transtilte"]=="1") then
         print ("QTR - tłumaczenia tytułów są włączone.");
      else
         print ("|cffffff00QTR - włączam tłumaczenia tytułów.");
         QTR_PS["transtitle"] = "1";
      end
   elseif (msg=="title off" or msg=="TITLE OFF") then
      if (QTR_PS["transtilte"]=="0") then
         print ("QTR - tłumaczenia tytułów są wyłączone.");
      else
         print ("|cffffff00QTR - wyłączam tłumaczenia tytułów.");
         QTR_PS["transtitle"] = "0";
      end
   elseif (msg=="mode 1" or msg=="MODE 1") then
      if (QTR_PS["mode"]=="1") then
         print ("QTR - tryb pracy 1 jest wyłączony.");
      else
         print ("|cffffff00QTR - włączam tryb pracy 1.");
         QTR_PS["mode"] = "1";
      end
   elseif (msg=="mode 2" or msg=="MODE 2") then
      if (QTR_PS["mode"]=="2") then
         print ("QTR - tryb pracy 2 jest wyłączony.");
      else
         print ("|cffffff00QTR - włączam tryb pracy 2.");
         QTR_PS["mode"] = "2";
      end
   else
      print ("QTR - menu szybkich komend addonu QuestTranslator:");
      print ("      /qtr on  - włącza tłumaczenia");
      print ("      /qtr off - wyłącza tłumaczenia");
      print ("      /qtr title on  - włącza tłumaczenie tytułu");
      print ("      /qtr title off - wyłącza tłumaczenie tytułu");
      print ("      /qtr mode 1  - włącza tryb pracy 1 (inside)");
      print ("      /qtr mode 2  - włącza tryb pracy 2 (next frame)");
   end
end


function QuestTranslator:ADDON_LOADED(_, addon)
  if (addon == "QuestTranslator") then
     SlashCmdList["QUESTTRANSLATOR"] = function(msg) QuestTranslator_SlashCommand(msg); end
     SLASH_QUESTTRANSLATOR1 = "/questtranslator";
     SLASH_QUESTTRANSLATOR2 = "/qtr";
     QuestTranslator_CheckVars();
--     QuestTranslator_BlizzardOptions();
     if (DEFAULT_CHAT_FRAME) then
         DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QuestTranslator ver. "..QTR_version.." "..QTR_lang.." - " .. QuestTranslator_Messages.loaded);
     else
         UIErrorsFrame:AddMessage("|cffffff00QuestTranslator ver. "..QTR_version.." "..QTR_lang.." - " .. QuestTranslator_Messages.loaded, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
     end
     self.frame1:UnregisterEvent("ADDON_LOADED");
     self.ADDON_LOADED = nil;
     if (not isGetQuestID) then
        DetectEmuServer();
     end;
  end
end


function QuestTranslator:QUEST_LOG_UPDATE()
  if (QuestTranslatorFrame1:IsVisible()) then
     QuestTranslator_UpdateQuestInfo();
  end
end


function QuestTranslator:WORLD_MAP_UPDATE()
  if ( WorldMapFrame:IsVisible() ) then
     if (QTR_PS["active"]=="1") then
        if (QTR_PS["mode"]=="1") then
--           if ( WorldMapPOIFrame:GetChecked() ) then
              QTR_event = "WORLD_MAP_UPDATE";
              QuestTranslator_OnEvent2();
--           end
	end
     end
  end
end


function DetectEmuServer()
  QTR_PS["isGetQuestID"]="0";
  isGetQuestID="0";
  -- function GetQuestID() don't work on wow-emulator servers - possible lua error when you first start - not significant
  if ( GetQuestID() ) then
     QTR_PS["isGetQuestID"]="1";
     isGetQuestID="1";
  end
end


function QTR_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(QTR_waitFrame == nil) then
    QTR_waitFrame = CreateFrame("Frame","QTR_WaitFrame", UIParent);
    QTR_waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #QTR_waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(QTR_waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(QTR_waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(QTR_waitTable,{delay,func,{...}});
  return true;
end


function QuestTranslator:QUEST_GREETING()
  if (QTR_PS["active"]=="1" and QTR_PS["mode"]=="1") then
     CurrentQuestsText:SetText(QuestTranslator_Messages.currquests);
     CurrentQuestsText:SetFont(QTR_Font1, 18);
     AvailableQuestsText:SetText(QuestTranslator_Messages.avaiquests);
     AvailableQuestsText:SetFont(QTR_Font1, 18);
  else
     CurrentQuestsText:SetText(QuestTranslator_MessOrig.currquests);
     CurrentQuestsText:SetFont(Original_Font1, 18);
     AvailableQuestsText:SetText(QuestTranslator_MessOrig.avaiquests);
     AvailableQuestsText:SetFont(Original_Font1, 18);
  end
end


function QuestTranslator:QUEST_DETAIL()
  QTR_event = "QUEST_DETAIL";
  if (isGetQuestID=="0") then
     if ( not QTR_wait(0.5,QuestTranslator_OnEvent2) ) then
        QuestTranslator_OnEvent2();
     end
  else
     QuestTranslator_OnEvent2();
  end
end


function QuestTranslator:QUEST_PROGRESS()
  QTR_event = "QUEST_PROGRESS";
  QuestTranslator_OnEvent2();
end


function QuestTranslator:QUEST_COMPLETE()
  QTR_event = "QUEST_COMPLETE";
  QuestTranslator_OnEvent2();
end


function QuestTranslator_OnEvent2()
  local q_ID = 0;
  local q_title = GetTitleText();
  local q_i = 1;

  if ( WorldMapFrame:IsVisible() ) then
    for i = 1, MAX_NUM_QUESTS do
      questFrame = _G["WorldMapQuestFrame"..i];
      if ( not questFrame ) then
        break
      elseif ( WORLDMAP_SETTINGS.selectedQuest==questFrame ) then
        q_title=questFrame.title:GetText();
        break;
      end
    end
  end

  -- search in QuestLog
  while GetQuestLogTitle(q_i) do
    local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(q_i)
    if ( not isHeader ) then
       if ( q_title == questTitle ) then
          q_ID=questID;
          break;
       end
    end
    q_i = q_i + 1;
  end
  RestoreOriginalFonts();
  if ( QTR_PS["active"]=="1" )then
     QuestTranslator_QuestID2:SetText("");
     QuestTranslator_QuestTitle2:SetText(q_title);
     QuestTranslator_QuestDetail2:SetText(QuestTranslator_Messages.missing);
     QuestTranslator_QuestWarning2:SetText("");
     -- not exist in QuestLog ?
     if ( q_ID == 0 ) then
        if ( isGetQuestID=="1" ) then
           q_ID = GetQuestID();
        end
        if ( q_ID == 0 ) then
           if (QuestTranslator_QuestList[q_title]) then
              local q_lists=QuestTranslator_QuestList[q_title];
              q_i=string.find(q_lists, ",");
              if ( string.find(q_lists, ",")==nil ) then
                 -- only 1 questID to this title
                 q_ID=tonumber(q_lists);
              else
                 -- multiple questIDs - get first, available (not completed) questID from QuestLists
                 local QTR_table=QTR_split(q_lists, ",");
                 local QTR_multiple = "";
                 local QTR_Center="";
                 for ii,vv in ipairs(QTR_table) do
                    if (not QTR_PC[vv]) then
                       if (QTR_Center=="") then
                           QTR_Center=vv;
                       else
                           QTR_multiple = QTR_multiple .. ", " .. vv;
                       end
                    end
                 end
                 if ( string.len(QTR_Center)>0 ) then
                    q_ID=tonumber(QTR_Center);
                    if ( string.len(QTR_multiple)>0 ) then
                       QTR_multiple = " (" .. string.sub(QTR_multiple, 3) .. ")";
                       QuestTranslator_QuestWarning2:SetText(QuestTranslator_Messages.multipleID .. QTR_multiple);
                    end
                 end
              end
           end
        end
     end
     if ( q_ID > 0 ) then
        local str_id = tostring(q_ID);
        QTR_ToggleButton0:SetText("Quest ID="..str_id.." ("..QTR_lang..")");
        QuestTranslator_QuestID2:SetText("QuestID: " .. str_id);
        QuestTranslator_QuestTitle2:SetText(q_title);
        if (QuestTranslator_QuestData[str_id]) then
           -- display only, if translation exists
	        if (QTR_PS["mode"]=="2") then
              QuestTranslator_ShowFrame2(QTR_event, str_id);
	        else
              QuestTranslator_ChangeText_InEvent(QTR_event, str_id);
           end
        else
           -- DEFAULT_CHAT_FRAME:AddMessage("QuestTranslator - Qid: "..tostring(q_ID).." ("..QuestTranslator_Messages.missing..")");
           QTR_SAVED[str_id.." TITLE"]=GetTitleText();               -- save original title to future translation
           if (QTR_event=="QUEST_DETAIL") then
              QTR_SAVED[str_id.." DESCRIPTION"]=GetQuestText();      -- save original text to future translation
              QTR_SAVED[str_id.." OBJECTIVE"]=GetObjectiveText();    -- save original text to future translation
           end
           if (QTR_event=="QUEST_PROGRESS") then
              QTR_SAVED[str_id.." PROGRESS"]=GetProgressText();      -- save original text to future translation
           end
           if (QTR_event=="QUEST_COMPLETE") then
              QTR_SAVED[str_id.." COMPLETE"]=GetRewardText();        -- save original text to future translation
           end
           QuestTranslatorFrame2:Hide();
        end
     end
  else   
     QTR_ToggleButton0:SetText("QTR nieaktywny");
  end
  if (QTR_event == "QUEST_COMPLETE") then
     if ( q_ID > 0) then
        local str_id = tostring(q_ID);
        QTR_PC[str_id]="OK";
     end
  end
end


function QuestTranslator_ShowFrame2(eventStr, qid)
  QuestTranslator_QuestID2:SetText("QuestID: " .. qid);
  QuestTranslator_QuestDetail2:SetText(QuestTranslator_Messages.missing);
  if (QuestTranslator_QuestData[qid]) then
     QuestTranslator_QuestTitle2:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Title"]));
     local QTR_text = "";
     if (eventStr == "QUEST_DETAIL") then
        if (QuestTranslator_QuestData[qid]["Description"]) then
           QTR_text = QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Description"]);
        end
        local QTR_text2 = "";
        if (QuestTranslator_QuestData[qid]["Objectives"]) then
           QTR_text2 = QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Objectives"]);
        end
        QTR_text = QTR_text .. "\n\n" .. QuestTranslator_Messages.objectives .. "\n" .. QTR_text2;
     end
     if (eventStr == "QUEST_PROGRESS") then
        if (QuestTranslator_QuestData[qid]["Progress"]) then
           QTR_text = QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Progress"]);
        end
     end
     if (eventStr == "QUEST_COMPLETE") then
        if (QuestTranslator_QuestData[qid]["Completion"]) then
           QTR_text = QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Completion"]);
        end
     end
     QuestTranslator_QuestDetail2:SetText(QTR_text);
     QuestTranslatorFrame2:ClearAllPoints();
     QuestTranslatorFrame2:SetPoint("TOPLEFT", QuestFrame, "TOPRIGHT", -1, -19);
     if ( QuestNPCModel ) then
        if ( QuestNPCModel:IsVisible() ) then
           QuestTranslatorFrame2:SetPoint("TOPLEFT", QuestNPCModel, "TOPRIGHT", 0, 42);
        end
     end
     QuestTranslatorFrame2:Show();
  end
end


function QuestTranslator_Frame2Close()
  QuestTranslatorFrame2:Hide();
  QuestFrame_OnHide();
end


function QTR_split(str, c)
  local aCount = 0;
  local array = {};
  local a = string.find(str, c);
  while a do
     aCount = aCount + 1;
     array[aCount] = string.sub(str, 1, a-1);
     str=string.sub(str, a+1);
     a = string.find(str, c);
  end
  aCount = aCount + 1;
  array[aCount] = str;
  return array;
end


function QTR_findlast(source, char)
  if (not source) then
     return 0;
  end
  local lastpos = 0;
  local byte_char = string.byte(char);
  for i=1, #source do
     if (string.byte(source,i)==byte_char) then
        lastpos = i;
     end
  end
  return lastpos;
end


function QuestTranslator_ChangeFrameHeight()
  -- normal height of Frame = 425, quest detail = 350
  if (QuestTranslator_SizeH == 1) then
     QuestTranslatorFrame1:SetHeight(525);
     QuestTranslator_QuestDetail:SetHeight(430);
     QTR_ToggleButton2:SetText("^");
     QuestTranslator_SizeH = 2;
     QTR_PS["size"] = "2";
  else
     QuestTranslatorFrame1:SetHeight(425);
     QuestTranslator_QuestDetail:SetHeight(350);
     QTR_ToggleButton2:SetText("v");
     QuestTranslator_SizeH = 1;
     QTR_PS["size"] = "1";
  end
end


function QuestTranslator_ChangeFrameWidth()
  -- normal width of Frame = 350, quest detail = 320
  if (QuestTranslator_SizeW == 1) then
     QuestTranslatorFrame1:SetWidth(525);
     QuestTranslator_QuestDetail:SetWidth(495);
     QuestTranslator_QuestTitle:SetWidth(495);
     QTR_ToggleButton3:SetText("<");
     QuestTranslator_SizeW = 2;
     QTR_PS["width"] = "2";
  else
     QuestTranslatorFrame1:SetWidth(350);
     QuestTranslator_QuestDetail:SetWidth(320);
     QuestTranslator_QuestTitle:SetWidth(320);
     QTR_ToggleButton3:SetText(">");
     QuestTranslator_SizeW = 1;
     QTR_PS["width"] = "1";
  end
end


function QuestTranslator_OnMouseDown1()
  -- start moving the window
  QuestTranslatorFrame1:StartMoving();
end
  

function QuestTranslator_OnMouseUp1()
  -- stop moving the window
  QuestTranslatorFrame1:StopMovingOrSizing();
end


function QuestTranslator_OnMouseDown2()
  -- start moving the window
  QuestTranslatorFrame2:StartMoving();
end
  

function QuestTranslator_OnMouseUp2()
  -- stop moving the window
  QuestTranslatorFrame2:StopMovingOrSizing();
end


function RestoreOriginalFonts()
  QuestInfoTitleHeader:SetFont(Original_Font1, 18);
  QuestInfoDescriptionHeader:SetText(QuestTranslator_MessOrig.details);
  QuestInfoDescriptionHeader:SetFont(Original_Font1, 18);
  QuestInfoDescriptionText:SetFont(Original_Font2, 13);
  QuestInfoObjectivesHeader:SetText(QuestTranslator_MessOrig.objectives);
  QuestInfoObjectivesHeader:SetFont(Original_Font1, 18);
  QuestInfoObjectivesText:SetFont(Original_Font2, 13);
  QuestInfoRewardsHeader:SetText(QuestTranslator_MessOrig.rewards);
  QuestInfoRewardsHeader:SetFont(Original_Font1, 18);
  QuestInfoRewardText:SetFont(Original_Font2, 13);
  --QuestInfoItemChooseText:SetText(QuestTranslator_MessOrig.itemchoose1);
  --QuestInfoItemChooseText:SetFont(Original_Font2, 13);
  --QuestInfoItemReceiveText:SetText(QuestTranslator_MessOrig.itemreceiv1);
  --QuestInfoItemReceiveText:SetFont(Original_Font2, 13);
  QuestInfoXPFrameReceiveText:SetText(QuestTranslator_MessOrig.experience);
  QuestInfoXPFrameReceiveText:SetFont(Original_Font2, 13);
  QuestInfoRequiredMoneyText:SetText(QuestTranslator_MessOrig.reqmoney);
  QuestInfoRequiredMoneyText:SetFont(Original_Font2, 13);
  QuestInfoSpellLearnText:SetText(QuestTranslator_MessOrig.learnspell);
  QuestInfoSpellLearnText:SetFont(Original_Font2, 13);
  QuestProgressTitleText:SetFont(Original_Font1, 18);
  QuestProgressText:SetFont(Original_Font2, 13);
  QuestProgressRequiredItemsText:SetText(QuestTranslator_MessOrig.reqitems);
  QuestProgressRequiredItemsText:SetFont(Original_Font1, 18);
  QuestProgressRequiredMoneyText:SetText(QuestTranslator_MessOrig.reqmoney);
  QuestProgressRequiredMoneyText:SetFont(Original_Font2, 13);
end


function QuestTranslator_ChangeText_InEvent(QTR_event, str_id)
  if (QTR_PS["transtitle"]=="1") then
     QuestInfoTitleHeader:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[str_id]["Title"]));
     QuestInfoTitleHeader:SetFont(QTR_Font1, 18);
     QuestProgressTitleText:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[str_id]["Title"]));
     QuestProgressTitleText:SetFont(QTR_Font1, 18);
  end
  QuestInfoDescriptionHeader:SetText(QuestTranslator_Messages.details);
  QuestInfoDescriptionHeader:SetFont(QTR_Font1, 18);
  QuestInfoDescriptionText:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[str_id]["Description"]));
  QuestInfoDescriptionText:SetFont(QTR_Font2, 13);
  QuestInfoObjectivesHeader:SetText(QuestTranslator_Messages.objectives);
  QuestInfoObjectivesHeader:SetFont(QTR_Font1, 18);
  QuestInfoObjectivesText:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[str_id]["Objectives"]));
  QuestInfoObjectivesText:SetFont(QTR_Font2, 13);
  QuestInfoRewardsHeader:SetText(QuestTranslator_Messages.rewards);
  QuestInfoRewardsHeader:SetFont(QTR_Font1, 18);
  QuestInfoRewardText:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[str_id]["Completion"]));
  QuestInfoRewardText:SetFont(QTR_Font2, 13);
  if (QTR_event=="QUEST_COMPLETE") then
     QuestInfoItemChooseText:SetText(QuestTranslator_Messages.itemchoose2);
     QuestInfoItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv2);
  else
     QuestInfoItemChooseText:SetText(QuestTranslator_Messages.itemchoose1);
     QuestInfoItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1);
  end
  QuestInfoItemChooseText:SetFont(QTR_Font2, 13);
  QuestInfoItemReceiveText:SetFont(QTR_Font2, 13);
  QuestInfoXPFrameReceiveText:SetText(QuestTranslator_Messages.experience);
  QuestInfoXPFrameReceiveText:SetFont(QTR_Font2, 13);
  QuestInfoRequiredMoneyText:SetText(QuestTranslator_Messages.reqmoney);
  QuestInfoRequiredMoneyText:SetFont(QTR_Font2, 13);
  QuestInfoSpellLearnText:SetText(QuestTranslator_Messages.learnspell);
  QuestInfoSpellLearnText:SetFont(QTR_Font2, 13);
  QuestProgressText:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[str_id]["Progress"]));
  QuestProgressText:SetFont(QTR_Font2, 13);
  QuestProgressRequiredMoneyText:SetText(QuestTranslator_Messages.reqmoney);
  QuestProgressRequiredMoneyText:SetFont(QTR_Font2, 13);
  QuestProgressRequiredItemsText:SetText(QuestTranslator_Messages.reqitems);
  QuestProgressRequiredItemsText:SetFont(QTR_Font1, 18);
end


function QuestTranslator_ChangeText_InQuestLog(qid)
  if (QTR_PS["transtitle"]=="1") then
     QuestInfoTitleHeader:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Title"]));
     QuestInfoTitleHeader:SetFont(QTR_Font1, 18);
  end
  QuestInfoDescriptionHeader:SetText(QuestTranslator_Messages.details);
  QuestInfoDescriptionHeader:SetFont(QTR_Font1, 18);
  
  QuestInfoDescriptionText:SetText(QTR_description);
  QuestInfoDescriptionText:SetFont(QTR_Font2, 13);
  
  QuestInfoObjectivesHeader:SetText(QuestTranslator_Messages.objectives);
  QuestInfoObjectivesHeader:SetFont(QTR_Font1, 18);
  QuestInfoObjectivesText:SetText(QTR_objectives);
  QuestInfoObjectivesText:SetFont(QTR_Font2, 13);
  QuestInfoRewardsHeader:SetText(QuestTranslator_Messages.rewards);
  QuestInfoRewardsHeader:SetFont(QTR_Font1, 18);
  --QuestInfoRewardText:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Completion"]));
  --QuestInfoRewardText:SetFont(QTR_Font2, 13);
  QuestInfoItemChooseText:SetText(QuestTranslator_Messages.itemchoose1);
  QuestInfoItemChooseText:SetFont(QTR_Font2, 13);
  QuestInfoItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1);
  QuestInfoItemReceiveText:SetFont(QTR_Font2, 13);
  QuestInfoXPFrameReceiveText:SetText(QuestTranslator_Messages.experience);
  QuestInfoXPFrameReceiveText:SetFont(QTR_Font2, 13);
  QuestInfoRequiredMoneyText:SetText(QuestTranslator_Messages.reqmoney);
  QuestInfoRequiredMoneyText:SetFont(QTR_Font2, 13);
  QuestInfoSpellLearnText:SetText(QuestTranslator_Messages.learnspell);
  QuestInfoSpellLearnText:SetFont(QTR_Font2, 13);
end


function QuestTranslator_ToggleVisibility()
  -- click on QTR button in QuestLogFrame
  if (QTR_PS["active"]=="0") then
     QTR_PS["active"] = "1";
     QTR_ToggleButton0:SetText("QTR aktywny");
     QTR_ToggleButton1:SetText("QTR aktywny");
     QTR_ToggleButton4:SetText("QTR aktywny");
     QTR_ToggleButton5:SetText("QTR aktywny");
     if (DEFAULT_CHAT_FRAME) then
         DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QuestTranslator "..QuestTranslator_Messages.isactive);
     else
         UIErrorsFrame:AddMessage("|cffffff00QuestTranslator "..QuestTranslator_Messages.isactive, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
     end
     QuestTranslator_ShowAndUpdateQuestInfo();
  else
     QTR_PS["active"] = "0";
     QTR_ToggleButton0:SetText("QTR nieaktywny");
     QTR_ToggleButton1:SetText("QTR nieaktywny");
     QTR_ToggleButton4:SetText("QTR nieaktywny");
     QTR_ToggleButton5:SetText("QTR nieaktywny");
     if ( WorldMapFrame:IsVisible() ) then
        if (WORLDMAP_SETTINGS.selectedQuest.index>0) then
           local questButtonX = _G["WorldMapQuestFrame"..WORLDMAP_SETTINGS.selectedQuest.index];
           WorldMapFrame_SelectQuestFrame(questButtonX);
        end
     else
        if ( QuestLogFrame:IsVisible() ) then
           if (GetQuestLogSelection()>1) then
              local questButtonX = _G["QuestLogScrollFrameButton"..GetQuestLogSelection()];
              questButtonX:Click();
           end
        end   
     end
     if (DEFAULT_CHAT_FRAME) then
         DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QuestTranslator "..QuestTranslator_Messages.isinactive);
     else
         UIErrorsFrame:AddMessage("|cffffff00QuestTranslator "..QuestTranslator_Messages.isinactive, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
     end
     QuestTranslator_HideQuestInfo();
     RestoreOriginalFonts();
  end
end


-- wywoływane, gdy otwierany jest QuestLog
function QuestTranslator_ShowAndUpdateQuestInfo()
  if (QTR_PS["active"]=="0") then
     QTR_ToggleButton0:SetText("QTR nieaktywny");
     QTR_ToggleButton1:SetText("QTR nieaktywny");
     QTR_ToggleButton4:SetText("QTR nieaktywny");
     QTR_ToggleButton5:SetText("QTR nieaktywny");
     return;
  end
  if (QTR_PS["mode"]=="2") then
     QuestTranslatorFrame1:Show();
  end;
  if ( QuestLogDetailFrame:IsVisible() ) then
     if ( not QTR_wait(0.5,QuestTranslator_UpdateQuestInfo) ) then
        QuestTranslator_UpdateQuestInfo();
     end
  else   
     QuestTranslator_UpdateQuestInfo();
  end   
end


function QuestTranslator_HideQuestInfo()
  QuestTranslatorFrame1:Hide();
end


function QuestTranslator_UpdateQuestInfo()
  if (QTR_PS["active"]=="0") then
     return;
  end
  local questSelected = GetQuestLogSelection();
  if (GetQuestLogTitle(questSelected) == nil) then
     QTR_ToggleButton0:SetText("QTR aktywny");
     QTR_ToggleButton1:SetText("QTR aktywny");
     QTR_ToggleButton4:SetText("QTR aktywny");
     QTR_ToggleButton5:SetText("QTR aktywny");
     return;
  end

  local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(questSelected);
  if (isHeader) then
     return;
  end

  local qid = tostring(questID);
  QuestTranslator_QuestID:SetText("QuestID: " .. qid);
  if (QTR_PS["active"]=="0") then
     QTR_ToggleButton0:SetText("Quest ID="..qid.." (EN)");
     QTR_ToggleButton1:SetText("Quest ID="..qid.." (EN)");
     QTR_ToggleButton4:SetText("Quest ID="..qid.." (EN)");
     QTR_ToggleButton5:SetText("Quest ID="..qid.." (EN)");
  else
     QTR_ToggleButton0:SetText("Quest ID="..qid.." ("..QTR_lang..")");
     QTR_ToggleButton1:SetText("Quest ID="..qid.." ("..QTR_lang..")");
     QTR_ToggleButton4:SetText("Quest ID="..qid.." ("..QTR_lang..")");
     QTR_ToggleButton5:SetText("Quest ID="..qid.." ("..QTR_lang..")");
  end

  if (QuestTranslator_QuestData[qid]) then
     QTR_objectives  = QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Objectives"]);
     QTR_description = QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Description"]);
     QTR_descripFull = QuestTranslator_Messages.details .. "\n" .. QTR_description;
     QTR_translator = "";
     if (QuestTranslator_QuestData[qid]["Translator"]) then
        if (QuestTranslator_QuestData[qid]["Translator"]>"") then
            QTR_translator = "\n\n" .. QuestTranslator_Messages.translator .. " " .. QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Translator"]);
        end
     end
     QuestTranslator_QuestTitle:SetText(QuestTranslator_ExpandUnitInfo(QuestTranslator_QuestData[qid]["Title"]));
     QuestTranslator_QuestDetail:SetText(QTR_objectives .. "\n\n" .. QTR_descripFull .. QTR_translator);
     if (QTR_PS["mode"]=="1") then		       -- translation direct into original QuestLog frame
        QuestTranslator_ChangeText_InQuestLog(qid);
     end
  else
     QuestTranslator_QuestTitle:SetText(questTitle);
     QuestTranslator_QuestDetail:SetText(QuestTranslator_Messages.missing);
     if (QTR_PS["mode"]=="1") then
	     RestoreOriginalFonts();
     end;
  end 
end


function QuestTranslator_ExpandUnitInfo(msg)
  -- replace special characters into message
  msg = string.gsub(msg, "NEW_LINE", "\n");
  msg = string.gsub(msg, "YOUR_NAME", QTR_name);
  msg = string.gsub(msg, "YOUR_CLASS", QTR_class);
  msg = string.gsub(msg, "YOUR_RACE", QTR_race);
  return msg;
end
